#include "GLnRgn.h"
#include "resource.h"

GLnRgn::GLnRgn(void)
{
}

GLnRgn::~GLnRgn(void)
{
}

bool GLnRgn::SetLnRgn(int LnMode)
{
	int mode=LN_STANDARD,i=0;
	switch(LnMode){
		case LNDSN_STANDARD0: 
		case LNDSN_STANDARD1: 
		case LNDSN_STANDARD2: 
		case LNDSN_STANDARD3: 
		case LNDSN_STANDARD4: 
			mode=LN_STANDARD; i=LnMode-LNDSN_STANDARD0;break;
		case LNDSN_CAT0:
		case LNDSN_CAT1:
		case LNDSN_CAT2:
		case LNDSN_CAT3:
		case LNDSN_CAT4:
			mode=LN_CAT; i=LnMode-LNDSN_CAT0; break;
		case LNDSN_STAR0:
		case LNDSN_STAR1:
		case LNDSN_STAR2:
		case LNDSN_STAR3:
		case LNDSN_STAR4:
			mode=LN_STAR; i=LnMode-LNDSN_STAR0; break;
		case LNDSN_CINDY0:
		case LNDSN_CINDY1:
		case LNDSN_CINDY2:
		case LNDSN_CINDY3:
		case LNDSN_CINDY4:
			mode=LN_CINDY; i=LnMode-LNDSN_CINDY0; break;
		case LNDSN_KSEG0:
		case LNDSN_KSEG1:
		case LNDSN_KSEG2:
		case LNDSN_KSEG3:
		case LNDSN_KSEG4:
			mode=LN_KSEG; i=LnMode-LNDSN_KSEG0; break;
		case LNDSN_PASTEL0:
		case LNDSN_PASTEL1:
		case LNDSN_PASTEL2:
		case LNDSN_PASTEL3:
		case LNDSN_PASTEL4:
			mode=LN_PASTEL; i=LnMode-LNDSN_PASTEL0; break;
		case LNDSN_SKELETON0:
			mode=LN_SKELETON; i=LnMode-LNDSN_SKELETON0; break;
	}
	switch(mode){
	case LN_STANDARD:
		LnRgn[0]._PT[0]=wxPoint(0,5);
		LnRgn[0]._PT[1]=wxPoint(20,5);
		LnRgn[0]._PT[2]=wxPoint(20,-5);
		LnRgn[0]._PT[3]=wxPoint(0,-5);
		LnRgn[0].SetGRgnBrush(255,64,255);
		LnRgn[0]._LGTH=4;
		LnRgn[0]._LineWidth=5;
		LnRgn[0]._LineLength=20;
		LnRgn[1]._PT[0]=wxPoint(0,3);
		LnRgn[1]._PT[1]=wxPoint(20,3);
		LnRgn[1]._PT[2]=wxPoint(20,-3);
		LnRgn[1]._PT[3]=wxPoint(0,-3);
		switch(i){
		case 0:
			LnRgn[1].SetGRgnBrush(64,255,64);break;
		case 1:
			LnRgn[1].SetGRgnBrush(64,64,255);break;
		case 2:
			LnRgn[1].SetGRgnBrush(255,64,64);break;
		case 3:
			LnRgn[1].SetGRgnBrush(255,64,255);break;
		default:
			LnRgn[1].SetGRgnBrush(64,255,255);break;
		}
		LnRgn[1]._LGTH=4;
		LnRgn[1]._LineWidth=4;
		LnRgn[1]._LineLength=20;
		LnRgn[2]._PT[0]=wxPoint(0,0);
		LnRgn[2]._PT[1]=wxPoint(10,0);
		LnRgn[2]._PT[2]=wxPoint(10,-2);
		LnRgn[2]._PT[3]=wxPoint(0,-2);
		switch(i){
		case 0:
			LnRgn[2].SetGRgnBrush(192,255,192);break;
		case 1:
			LnRgn[2].SetGRgnBrush(192,192,255);break;
		case 2:
			LnRgn[2].SetGRgnBrush(255,192,192);break;
		case 3:
			LnRgn[2].SetGRgnBrush(255,192,255);break;
		default:
			LnRgn[2].SetGRgnBrush(192,255,255);break;
		}
		LnRgn[2]._LGTH=4;
		LnRgn[2]._LineWidth=4;
		LnRgn[2]._LineLength=20;
		NLnRgn=3;
		return false;
		break;
	case LN_CAT:
		LnRgn[0]._PT[0]=wxPoint(0,7);
		LnRgn[0]._PT[1]=wxPoint(24,7);
		LnRgn[0]._PT[2]=wxPoint(24,-7);
		LnRgn[0]._PT[3]=wxPoint(0,-7);
		LnRgn[0].SetGRgnBrush(255,128,128);
		LnRgn[0]._LGTH=4;
		LnRgn[0]._LineWidth=7;
		LnRgn[0]._LineLength=20;
		LnRgn[1]._PT[0]=wxPoint(0,5);
		LnRgn[1]._PT[1]=wxPoint(3,5);
		LnRgn[1]._PT[2]=wxPoint(7,0);
		LnRgn[1]._PT[3]=wxPoint(3,-5);
		LnRgn[1]._PT[4]=wxPoint(0,-5);
		switch(i){
		case 0:
			LnRgn[1].SetGRgnBrush(160,120,120);break;
		case 1:
			LnRgn[1].SetGRgnBrush(50,0,0);break;
		case 2:
			LnRgn[1].SetGRgnBrush(80,50,50);break;
		case 3:
			LnRgn[1].SetGRgnBrush(255,200,0);break;
		default:
			LnRgn[1].SetGRgnBrush(100,50,50);break;
		}
		LnRgn[1]._LGTH=5;
		LnRgn[1]._LineWidth=5;
		LnRgn[1]._LineLength=20;
		LnRgn[2]._PT[0]=wxPoint(3,0);
		LnRgn[2]._PT[1]=wxPoint(7,5);
		LnRgn[2]._PT[2]=wxPoint(13,5);
		LnRgn[2]._PT[3]=wxPoint(17,0);
		LnRgn[2]._PT[4]=wxPoint(13,-5);
		LnRgn[2]._PT[5]=wxPoint(7,-5);
		switch(i){
		case 0:
			LnRgn[2].SetGRgnBrush(200,160,160);break;
		case 1:
			LnRgn[2].SetGRgnBrush(200,160,160);break;
		case 2:
			LnRgn[2].SetGRgnBrush(255,200,200);break;
		case 3:
			LnRgn[2].SetGRgnBrush(255,200,200);break;
		default:
			LnRgn[2].SetGRgnBrush(255,200,150);break;
		}
		LnRgn[2]._LGTH=6;
		LnRgn[2]._LineWidth=5;
		LnRgn[2]._LineLength=20;
		LnRgn[3]._PT[0]=wxPoint(13,0);
		LnRgn[3]._PT[1]=wxPoint(17,5);
		LnRgn[3]._PT[2]=wxPoint(20,5);
		LnRgn[3]._PT[3]=wxPoint(20,-5);
		LnRgn[3]._PT[4]=wxPoint(17,-5);
		switch(i){
		case 0:
			LnRgn[3].SetGRgnBrush(160,120,120);break;
		case 1:
			LnRgn[3].SetGRgnBrush(50,0,0);break;
		case 2:
			LnRgn[3].SetGRgnBrush(255,150,50);break;
		case 3:
			LnRgn[3].SetGRgnBrush(255,200,150);break;
		default:
			LnRgn[3].SetGRgnBrush(100,50,50);break;
		}
		LnRgn[3]._LGTH=5;
		LnRgn[3]._LineWidth=5;
		LnRgn[3]._LineLength=20;
		NLnRgn=4;
		return false;
		break;
	case LN_STAR:
		LnRgn[0]._PT[0]=wxPoint(0,-3);
		LnRgn[0]._PT[1]=wxPoint(5,7);
		LnRgn[0]._PT[2]=wxPoint(11,7);
		LnRgn[0]._PT[3]=wxPoint(16,-3);
		LnRgn[0]._PT[4]=wxPoint(8,-7);
		LnRgn[0].SetGRgnBrush(255,128,64);
		LnRgn[0]._LGTH=5;
		LnRgn[0]._LineWidth=7;
		LnRgn[0]._LineLength=24;
		LnRgn[1]._PT[0]=wxPoint(0,-3);
		LnRgn[1]._PT[1]=wxPoint(11,7);
		LnRgn[1]._PT[2]=wxPoint(8,-7);
		LnRgn[1]._PT[3]=wxPoint(5,7);
		LnRgn[1]._PT[4]=wxPoint(16,-3);
		LnRgn[1].SetGRgnBrush(255,255,64);
		switch(i){
		case 0:
			LnRgn[1].SetGRgnBrush(255,255,64);break;
		case 1:
			LnRgn[1].SetGRgnBrush(236,191,25);break;
		case 2:
			LnRgn[1].SetGRgnBrush(198,230,78);break;
		case 3:
			LnRgn[1].SetGRgnBrush(251,192,223);break;
		default:
			LnRgn[1].SetGRgnBrush(139,211,239);break;
		}
		LnRgn[1]._LGTH=5;
		LnRgn[1]._LineWidth=7;
		LnRgn[1]._LineLength=24;
		LnRgn[2]._PT[0]=wxPoint(4,-1);
		LnRgn[2]._PT[1]=wxPoint(5,0);
		LnRgn[2]._PT[2]=wxPoint(6,-1);
		LnRgn[2]._PT[3]=wxPoint(6,-2);
		LnRgn[2]._PT[4]=wxPoint(5,-3);
		LnRgn[2]._PT[5]=wxPoint(4,-2);
		LnRgn[2].SetGRgnBrush(255,255,128);
		LnRgn[2]._LGTH=6;
		LnRgn[2]._LineWidth=7;
		LnRgn[2]._LineLength=15;
		NLnRgn=3;
		return false;
		break;
	//case LN_JEWEL:
	//	LnRgn[0]._PT[0]=wxPoint(0,3);
	//	LnRgn[0]._PT[1]=wxPoint(10,5);
	//	LnRgn[0]._PT[2]=wxPoint(20,3);
	//	LnRgn[0]._PT[3]=wxPoint(20,-3);
	//	LnRgn[0]._PT[4]=wxPoint(10,-5);
	//	LnRgn[0]._PT[5]=wxPoint(0,-3);
	//	LnRgn[0].SetGRgnBrush(255,64,64);
	//	LnRgn[0]._LGTH=6;
	//	LnRgn[0]._LineWidth=3;
	//	LnRgn[0]._LineLength=20;
	//	LnRgn[1]._PT[0]=wxPoint(2,2);
	//	LnRgn[1]._PT[1]=wxPoint(4,2);
	//	LnRgn[1]._PT[2]=wxPoint(4,0);
	//	LnRgn[1]._PT[3]=wxPoint(15,0);
	//	LnRgn[1]._PT[4]=wxPoint(15,-2);
	//	LnRgn[1]._PT[5]=wxPoint(2,-2);
	//	LnRgn[1].SetGRgnBrush(255,128,128);
	//	LnRgn[1]._LGTH=6;
	//	LnRgn[1]._LineWidth=3;
	//	LnRgn[1]._LineLength=20;
	//	NLnRgn=2;
	//	return false;
	//	break;
	case LN_KSEG:
		LnRgn[0]._PT[0]=wxPoint(0,1);
		LnRgn[0]._PT[1]=wxPoint(20,1);
		LnRgn[0]._PT[2]=wxPoint(20,-1);
		LnRgn[0]._PT[3]=wxPoint(0,-1);
		LnRgn[0].SetGRgnBrush(255,20,20);
		LnRgn[0]._LGTH=4;
		LnRgn[0]._LineWidth=2;
		LnRgn[0]._LineLength=20;
		LnRgn[1]._PT[0]=wxPoint(0,0);
		LnRgn[1]._PT[1]=wxPoint(20,0);
		switch(i){
		case 0:
			LnRgn[1].SetGRgnBrush(20,20,20);break;
		case 1:
			LnRgn[1].SetGRgnBrush(80,20,20);break;
		case 2:
			LnRgn[1].SetGRgnBrush(20,80,80);break;
		case 3:
			LnRgn[1].SetGRgnBrush(20,80,20);break;
		default:
			LnRgn[1].SetGRgnBrush(20,20,80);break;
		}
		LnRgn[1]._LGTH=2;
		LnRgn[1]._LineWidth=2;
		LnRgn[1]._LineLength=20;
		NLnRgn=2;
		return false;
		break;
	case LN_CINDY:
		LnRgn[0]._PT[0]=wxPoint(0,1);
		LnRgn[0]._PT[1]=wxPoint(20,1);
		LnRgn[0]._PT[2]=wxPoint(20,-1);
		LnRgn[0]._PT[3]=wxPoint(0,-1);
		LnRgn[0].SetGRgnBrush(255,255,255);
		LnRgn[0]._LGTH=4;
		LnRgn[0]._LineWidth=2;
		LnRgn[0]._LineLength=20;
		LnRgn[1]._PT[0]=wxPoint(0,0);
		LnRgn[1]._PT[1]=wxPoint(20,0);
		switch(i){
		case 0:
			LnRgn[1].SetGRgnBrush(10,10,255);break;
		case 1:
			LnRgn[1].SetGRgnBrush(200,0,50);break;
		case 2:
			LnRgn[1].SetGRgnBrush(50,200,255);break;
		case 3:
			LnRgn[1].SetGRgnBrush(50,200,0);break;
		default:
			LnRgn[1].SetGRgnBrush(255,50,150);break;
		}
		LnRgn[1]._LGTH=2;
		LnRgn[1]._LineWidth=2;
		LnRgn[1]._LineLength=20;
		NLnRgn=2;
		return false;
		break;
	case LN_PASTEL:
		LnRgn[0]._PT[0]=wxPoint(0,5);
		LnRgn[0]._PT[1]=wxPoint(20,5);
		LnRgn[0]._PT[2]=wxPoint(20,-5);
		LnRgn[0]._PT[3]=wxPoint(0,-5);
		LnRgn[0].SetGRgnBrush(255,255,128);
		LnRgn[0]._LGTH=4;
		LnRgn[0]._LineWidth=4;
		LnRgn[0]._LineLength=20;
		LnRgn[1]._PT[0]=wxPoint(0,3);
		LnRgn[1]._PT[1]=wxPoint(20,3);
		LnRgn[1]._PT[2]=wxPoint(20,-3);
		LnRgn[1]._PT[3]=wxPoint(0,-3);
		switch(i){
		case 0:
			LnRgn[1].SetGRgnBrush(128,255,128);break;
		case 1:
			LnRgn[1].SetGRgnBrush(236,191,25);break;
		case 2:
			LnRgn[1].SetGRgnBrush(198,230,78);break;
		case 3:
			LnRgn[1].SetGRgnBrush(251,192,223);break;
		default:
			LnRgn[1].SetGRgnBrush(139,211,239);break;
		}
		LnRgn[1]._LGTH=4;
		LnRgn[1]._LineWidth=4;
		LnRgn[1]._LineLength=20;
		NLnRgn=2;
		return false;
		break;
	case LN_SKELETON:
		LnRgn[0]._PT[0]=wxPoint(5,0);
		LnRgn[0]._PT[1]=wxPoint(7,5);
		LnRgn[0]._PT[2]=wxPoint(11,5);
		LnRgn[0]._PT[3]=wxPoint(13,0);
		LnRgn[0]._PT[4]=wxPoint(11,-5);
		LnRgn[0]._PT[5]=wxPoint(7,-5);
		LnRgn[0].SetGRgnBrush(255,0,0);
		LnRgn[0]._LGTH=6;
		LnRgn[0]._LineWidth=5;
		LnRgn[0]._LineLength=20;
		LnRgn[1]._PT[0]=wxPoint(0,-2);
		LnRgn[1]._PT[1]=wxPoint(2,0);
		LnRgn[1]._PT[2]=wxPoint(0,2);
		LnRgn[1]._PT[3]=wxPoint(2,4);
		LnRgn[1]._PT[4]=wxPoint(4,2);
		LnRgn[1]._PT[5]=wxPoint(14,2);
		LnRgn[1]._PT[6]=wxPoint(16,4);
		LnRgn[1]._PT[7]=wxPoint(18,2);
		LnRgn[1]._PT[8]=wxPoint(16,0);
		LnRgn[1]._PT[9]=wxPoint(18,-2);
		LnRgn[1]._PT[10]=wxPoint(16,-4);
		LnRgn[1]._PT[11]=wxPoint(14,-2);
		LnRgn[1]._PT[12]=wxPoint(4,-2);
		LnRgn[1]._PT[13]=wxPoint(2,-4);
		LnRgn[1].SetGRgnBrush(255,255,255);
		LnRgn[1]._LGTH=14;
		LnRgn[1]._LineWidth=4;
		LnRgn[1]._LineLength=20;
		NLnRgn=2;
		return false;
		break;
	}
	return true;
}

