#ifndef __GOBJECT__
#define __GOBJECT__
#include <wx/pen.h>
#include <wx/brush.h>
class GObject
{
public:
	GObject(void);
	virtual ~GObject(void);
	wxString _name;
	int _fontsize;
	wxPen outsidepen;
	wxBrush outsidebrush;
	short hilightphase;
	bool hilighted;
	int vanishing; // 0,1,2,3  0:full-appearing,  3 : almost vanishing
	bool invisible;  // true: invisible, false:visible
	int animation_phase; //  -1:off,  0,1,2,3~ : phase number
	int animation_inout; //  0 : in , 1 : out, 2 : emphasis
	int animation_click; //  0 : immediately, 1 : when clicked
	int animation_direction; // 0 : fade , 1 : right , 2 : left , 3 : top , 4 : bottom
	int animation_effect; // 0 :nothing , 1 : do effect after(before) animation 
	int offsetx;
	int offsety;
	int velocity;
	double expand;
	double interval;
	int r_off,l_off,t_off,b_off;

};
#endif
