//
//
//    GText.h
//         by K. Ahara
//

#ifndef __GTEXT__
#define __GTEXT__

#include "GObject.h"

class GText :
	public GObject
{
public:
	GText(void){str=wxT("");};
	GText(wxString a){str=a;};
	GText(const GText& p){str=p.str;};
	~GText(void){};
	wxString str;
	double tx,ty;
	double fontsize;
	int ColR,ColG,ColB;
	bool used;
	bool centered;
	GText* next;
	int m_text_dragging_h_length;
	int m_text_dragging_h_height;
	
	wxString& text(void){return str;};
	void SetText(wxString s){str=s;};
	void SetOffset(int van,int ox,int oy,int vel);
	void ClearHilight(void){
		hilighted=false;
		if(next!=NULL){
			next->ClearHilight();
		}
	};
};

#endif

