//
//  PropertyDialog.h
//


class AppearanceDialog : public wxDialog
{
public:
	AppearanceDialog(wxWindow *parent,int *PtMode,int *LnMode,int BgMode,int *AngleColR,int *AngleColG,int *AngleColB);

	wxComboBox *m_ComboBox_P[5];
	wxComboBox *m_ComboBox_L[5];
	wxComboBox *m_ComboBox_BG;
	wxButton* m_btnOk,*	m_btnCancel;
	wxString Pchoices[PTBMP_MAX];
	wxString Lchoices[LNDSN_MAX];
	wxString BGchoices[BG_MAX];
	wxColourData m_ColData;


private:
	//DECLARE_EVENT_TABLE()
};

enum{
	ID_APPEAR_PT1,
	ID_APPEAR_PT2,
	ID_APPEAR_PT3,
	ID_APPEAR_PT4,
	ID_APPEAR_PT5,
	ID_APPEAR_LN1,
	ID_APPEAR_LN2,
	ID_APPEAR_LN3,
	ID_APPEAR_LN4,
	ID_APPEAR_LN5,
	ID_APPEAR_RGB1,
	ID_APPEAR_RGB2,
	ID_APPEAR_RGB3,
	ID_APPEAR_RGB4,
	ID_APPEAR_RGB5,
	ID_APPEAR_LAST
};

//BEGIN_EVENT_TABLE(AppearanceDialog, wxDialog)

//END_EVENT_TABLE()

AppearanceDialog::AppearanceDialog(wxWindow *parent,int *PtMode,int *LnMode,int BgMode,int *AngleColR,int *AngleColG,int *AngleColB)
			 : wxDialog(parent, wxID_ANY,EditTextDlogTitle,wxPoint(15,15), wxSize(770,250))
{
	Pchoices[PTBMP_BALL0]=wxT("Standard1");
	Pchoices[PTBMP_BALL1]=wxT("Standard2");
	Pchoices[PTBMP_BALL2]=wxT("Standard3");
	Pchoices[PTBMP_BALL3]=wxT("Standard4");
	Pchoices[PTBMP_BALL4]=wxT("Standard5");
	Pchoices[PTBMP_CAT0]=wxT("Cat1");
	Pchoices[PTBMP_CAT1]=wxT("Cat2");
	Pchoices[PTBMP_CAT2]=wxT("Cat3");
	Pchoices[PTBMP_CAT3]=wxT("Cat4");
	Pchoices[PTBMP_CAT4]=wxT("Cat5");
	Pchoices[PTBMP_STAR0]=wxT("Star1");
	Pchoices[PTBMP_STAR1]=wxT("Star2");
	Pchoices[PTBMP_STAR2]=wxT("Star3");
	Pchoices[PTBMP_STAR3]=wxT("Star4");
	Pchoices[PTBMP_STAR4]=wxT("Star5");
	Pchoices[PTBMP_SKELETON0]=wxT("Skeleton");
	Pchoices[PTBMP_CINDY0]=wxT("Cindy1");
	Pchoices[PTBMP_CINDY1]=wxT("Cindy2");
	Pchoices[PTBMP_CINDY2]=wxT("Cindy3");
	Pchoices[PTBMP_CINDY3]=wxT("Cindy4");
	Pchoices[PTBMP_CINDY4]=wxT("Cindy5");
	Pchoices[PTBMP_KSEG0]=wxT("KSEG1");
	Pchoices[PTBMP_KSEG1]=wxT("KSEG2");
	Pchoices[PTBMP_KSEG2]=wxT("KSEG3");
	Pchoices[PTBMP_KSEG3]=wxT("KSEG4");
	Pchoices[PTBMP_KSEG4]=wxT("KSEG5");
	Pchoices[PTBMP_PASTEL0]=wxT("Pastel1");
	Pchoices[PTBMP_PASTEL1]=wxT("Pastel2");
	Pchoices[PTBMP_PASTEL2]=wxT("Pastel3");
	Pchoices[PTBMP_PASTEL3]=wxT("Pastel4");
	Pchoices[PTBMP_PASTEL4]=wxT("Pastel5");
	Pchoices[PTBMP_USER0]=wxT("User1");
	Pchoices[PTBMP_USER1]=wxT("User2");
	Pchoices[PTBMP_USER2]=wxT("User3");
	Pchoices[PTBMP_USER3]=wxT("User4");
	Pchoices[PTBMP_USER4]=wxT("User5");

	Lchoices[LNDSN_STANDARD0]=wxT("Standard1");
	Lchoices[LNDSN_STANDARD1]=wxT("Standard2");
	Lchoices[LNDSN_STANDARD2]=wxT("Standard3");
	Lchoices[LNDSN_STANDARD3]=wxT("Standard4");
	Lchoices[LNDSN_STANDARD4]=wxT("Standard5");
	Lchoices[LNDSN_CAT0]=wxT("Cat1");
	Lchoices[LNDSN_CAT1]=wxT("Cat2");
	Lchoices[LNDSN_CAT2]=wxT("Cat3");
	Lchoices[LNDSN_CAT3]=wxT("Cat4");
	Lchoices[LNDSN_CAT4]=wxT("Cat5");
	Lchoices[LNDSN_STAR0]=wxT("Star1");
	Lchoices[LNDSN_STAR1]=wxT("Star2");
	Lchoices[LNDSN_STAR2]=wxT("Star3");
	Lchoices[LNDSN_STAR3]=wxT("Star4");
	Lchoices[LNDSN_STAR4]=wxT("Star5");
	Lchoices[LNDSN_SKELETON0]=wxT("Skeleton");
	Lchoices[LNDSN_CINDY0]=wxT("Cindy1");
	Lchoices[LNDSN_CINDY1]=wxT("Cindy2");
	Lchoices[LNDSN_CINDY2]=wxT("Cindy3");
	Lchoices[LNDSN_CINDY3]=wxT("Cindy4");
	Lchoices[LNDSN_CINDY4]=wxT("Cindy5");
	Lchoices[LNDSN_KSEG0]=wxT("KSEG1");
	Lchoices[LNDSN_KSEG1]=wxT("KSEG2");
	Lchoices[LNDSN_KSEG2]=wxT("KSEG3");
	Lchoices[LNDSN_KSEG3]=wxT("KSEG4");
	Lchoices[LNDSN_KSEG4]=wxT("KSEG5");
	Lchoices[LNDSN_PASTEL0]=wxT("Pastel1");
	Lchoices[LNDSN_PASTEL1]=wxT("Pastel2");
	Lchoices[LNDSN_PASTEL2]=wxT("Pastel3");
	Lchoices[LNDSN_PASTEL3]=wxT("Pastel4");
	Lchoices[LNDSN_PASTEL4]=wxT("Pastel5");
	Lchoices[LNDSN_USER0]=wxT("User1");
	Lchoices[LNDSN_USER1]=wxT("User2");
	Lchoices[LNDSN_USER2]=wxT("User3");
	Lchoices[LNDSN_USER3]=wxT("User4");
	Lchoices[LNDSN_USER4]=wxT("User5");

	//Achoices[AGDSN_0]=wxT("Single");
	//Achoices[AGDSN_1]=wxT("Double");
	//Achoices[AGDSN_2]=wxT("One Segment");
	//Achoices[AGDSN_3]=wxT("Two Segments");
	//Achoices[AGDSN_4]=wxT("Circle");


	BGchoices[BG_STANDARD0]=wxT("KC1");
	BGchoices[BG_STANDARD1]=wxT("KC2");
	BGchoices[BG_STANDARD2]=wxT("KC3");
	BGchoices[BG_CAT]=wxT("Cat");
	BGchoices[BG_STAR]=wxT("Star");
	BGchoices[BG_SKELETON]=wxT("Skeleton");
	BGchoices[BG_CINDY]=wxT("Cindy");
	BGchoices[BG_KSEG]=wxT("KSEG");
	BGchoices[BG_PASTEL]=wxT("Pastel");
	BGchoices[BG_USER0]=wxT("User1");
	BGchoices[BG_USER1]=wxT("User2");
	BGchoices[BG_USER2]=wxT("User3");
	
	new wxStaticText(this, wxID_ANY,MenuPt1,wxPoint(10,10));
	new wxStaticText(this, wxID_ANY,MenuPt2,wxPoint(10,40));
	new wxStaticText(this, wxID_ANY,MenuPt3,wxPoint(10,70));
	new wxStaticText(this, wxID_ANY,MenuPt4,wxPoint(10,100));
	new wxStaticText(this, wxID_ANY,MenuPt5,wxPoint(10,130));
	new wxStaticText(this, wxID_ANY,MenuLine1,wxPoint(200,10));
	new wxStaticText(this, wxID_ANY,MenuLine2,wxPoint(200,40));
	new wxStaticText(this, wxID_ANY,MenuLine3,wxPoint(200,70));
	new wxStaticText(this, wxID_ANY,MenuLine4,wxPoint(200,100));
	new wxStaticText(this, wxID_ANY,MenuLine5,wxPoint(200,130));
	//new wxStaticText(this, wxID_ANY,MenuAppearAngle,wxPoint(390,10));
	new wxStaticText(this, wxID_ANY,MenuAppearBG,wxPoint(10,175));
	int i;
	for(i=0;i<5;i++){
		m_ComboBox_P[i] = new wxComboBox(this, ID_APPEAR_PT1+i,Pchoices[PtMode[i]],wxPoint(60,10+30*i),wxSize(100,20),PTBMP_MAX,Pchoices);
		m_ComboBox_L[i] = new wxComboBox(this, ID_APPEAR_LN1+i,Lchoices[LnMode[i]],wxPoint(250,10+30*i),wxSize(100,20),LNDSN_MAX,Lchoices);
	}
	m_ComboBox_BG = new wxComboBox(this, ID_APPEAR_BG,BGchoices[BgMode],wxPoint(60,175),wxSize(100,20),BG_MAX,BGchoices);
	m_btnOk = new wxButton(this, wxID_OK, wxT("Ok"),wxPoint(250,175), wxSize(80,20));
	m_btnCancel = new wxButton(this, wxID_CANCEL, wxT("Cancel"),wxPoint(340,175), wxSize(80,20));
}

#include "wx/colordlg.h"
#include "wx/cmndata.h"



enum{
	BracketPropertyStyle,
	BracketPropertyCaption,
	BracketPropertyRGB,
	BracketPropertyMAX
};

enum{
	BRDSN_0,
	BRDSN_1,
	BRDSN_2,
	BRDSN_3,
	BRDSN_4,
	BRDSN_MAX
} ; 

class BracketPropertyDialog : public wxDialog
{
public:
	BracketPropertyDialog(wxWindow *parent,GBracket* brp);

	wxTextCtrl *m_Name;

	wxRadioButton *m_rb_style,*m_rb_caption;
	wxComboBox *m_cmb_style;
	wxString m_style_list[BRDSN_MAX];
	wxTextCtrl *m_caption;
	wxTextCtrl *m_height;

	wxTextCtrl *m_ColorR,*m_ColorG,*m_ColorB;
	wxButton *m_RGB;
	
	wxButton *m_btnOk, *m_btnCancel;
	wxColourData m_ColData;
	
	void OnStyle(wxCommandEvent& event);
	void OnCaption(wxCommandEvent& event);
	void OnRGB(wxCommandEvent& event);

private:
	DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(BracketPropertyDialog, wxDialog)
	EVT_RADIOBUTTON(BracketPropertyStyle, BracketPropertyDialog::OnStyle)
	EVT_RADIOBUTTON(BracketPropertyCaption, BracketPropertyDialog::OnCaption)
	EVT_BUTTON(BracketPropertyRGB,BracketPropertyDialog::OnRGB)

END_EVENT_TABLE()

BracketPropertyDialog::BracketPropertyDialog(wxWindow *parent,GBracket* brp)
			 : wxDialog(parent, wxID_ANY,ToolText_Property,wxPoint(15,15), wxSize(500,240))
{
	m_style_list[BRDSN_0]=wxT("Simple");
	m_style_list[BRDSN_1]=wxT("Single segment");
	m_style_list[BRDSN_2]=wxT("Double segments");
	m_style_list[BRDSN_3]=wxT("Circle");
	m_style_list[BRDSN_4]=wxT("Check");
	//name
	int col,row;
	int row0=30,row1=90;
	col=10;
	row=row0;
	new wxStaticText(this, wxID_ANY,wxT("Name  =  "),wxPoint(row,col+3)); row=row1;
	char buffer[128];
	sprintf(buffer,"%s",brp->_name.c_str()); 
	m_Name = new wxTextCtrl(this, wxID_ANY,wxString((char*)buffer,wxConvUTF8),wxPoint(row,col),wxSize(80,20),wxTE_READONLY);
	// style
	col+=30;
	row=row0;
	m_rb_style = new wxRadioButton(this,BracketPropertyStyle,wxT("Style  = "),wxPoint(row,col),wxSize(100,20)); row += 120;
	if(brp->m_bracket_design>=0){
		m_cmb_style = new wxComboBox(this,wxID_ANY,m_style_list[brp->m_bracket_design],wxPoint(row,col),wxSize(200,20),BRDSN_MAX,m_style_list);
	}
	else {
		m_cmb_style = new wxComboBox(this,wxID_ANY,m_style_list[0],wxPoint(row,col),wxSize(200,20),BRDSN_MAX,m_style_list);
	}
	// caption
	col+=30;
	row=row0;
	m_rb_caption = new wxRadioButton(this,BracketPropertyCaption,wxT("Caption= "),wxPoint(row,col),wxSize(80,20)); row+=100;
	sprintf(buffer,"%s",brp->caption.c_str()); 
	m_caption = new wxTextCtrl(this,wxID_ANY,wxString((char*)buffer,wxConvUTF8),wxPoint(row,col),wxSize(80,20));
	if(brp->m_bracket_design>=0){
		m_rb_style->SetValue(true);
		m_caption->Disable();
		m_cmb_style->Enable();
	}
	else {
		m_rb_caption->SetValue(true);
		m_caption->Enable();
		m_cmb_style->Disable();
	}
	// height
	col+=30;
	row=row0;
	new wxStaticText(this, wxID_ANY,wxT("Height= "),wxPoint(row,col+3)); row=row1;
	m_height = new wxTextCtrl(this,wxID_ANY,wxString::Format(wxT("%.3f"),brp->m_bracket_height),wxPoint(row,col),wxSize(80,20));
	// color
	col+=30;
	row=row0;
	new wxStaticText(this, wxID_ANY,wxT("Color  = "),wxPoint(row,col+3)); row=row1;
	m_ColorR = new wxTextCtrl(this, wxID_ANY,wxString::Format(wxT("%d"),brp->ColR),wxPoint(row,col),wxSize(50,20)); row+=60;
	m_ColorG = new wxTextCtrl(this, wxID_ANY,wxString::Format(wxT("%d"),brp->ColG),wxPoint(row,col),wxSize(50,20)); row+=60;
	m_ColorB = new wxTextCtrl(this, wxID_ANY,wxString::Format(wxT("%d"),brp->ColB),wxPoint(row,col),wxSize(50,20)); row+=60;
	m_RGB = new wxButton(this, BracketPropertyRGB,wxT("RGB"),wxPoint(row,col),wxSize(50,20));
	// ok,cancel
	col+=30;
	m_btnOk = new wxButton(this, wxID_OK, wxT("Ok"),wxPoint(300,col), wxSize(80,20));
	m_btnCancel = new wxButton(this, wxID_CANCEL, wxT("Cancel"),wxPoint(400,col), wxSize(80,20));

}

void BracketPropertyDialog::OnStyle(wxCommandEvent& event)
{
	m_caption->Disable();
	m_cmb_style->Enable();
}
void BracketPropertyDialog::OnCaption(wxCommandEvent& event)
{
	m_caption->Enable();
	m_cmb_style->Disable();
}
void BracketPropertyDialog::OnRGB(wxCommandEvent& event)
{
	wxColourDialog dialog(this, &m_ColData);
	if (dialog.ShowModal() == wxID_OK){
		wxColourData retData = dialog.GetColourData();
		wxColour col = retData.GetColour();
		m_ColorR->SetValue(wxString::Format(wxT("%d"),(int)(col.Red())));
		m_ColorG->SetValue(wxString::Format(wxT("%d"),(int)(col.Green())));
		m_ColorB->SetValue(wxString::Format(wxT("%d"),(int)(col.Blue())));

	}
}

enum{
	AnglePropertyRGB,
	AnglePropertyMAX
};

enum{
	AGDSN_0,
	AGDSN_1,
	AGDSN_2,
	AGDSN_3,
	AGDSN_4,
	AGDSN_MAX
} ; 

class AnglePropertyDialog : public wxDialog
{
public:
	AnglePropertyDialog(wxWindow *parent,GAngle* agp);

	wxTextCtrl *m_Name;

	wxComboBox *m_cmb_style;
	wxString m_style_list[AGDSN_MAX];

	wxTextCtrl *m_size;

	wxTextCtrl *m_ColorR,*m_ColorG,*m_ColorB;
	wxButton *m_RGB;
	
	wxButton *m_btnOk, *m_btnCancel;
	wxColourData m_ColData;
	
	void OnRGB(wxCommandEvent& event);

private:
	DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(AnglePropertyDialog, wxDialog)
	EVT_BUTTON(AnglePropertyRGB,AnglePropertyDialog::OnRGB)

END_EVENT_TABLE()

AnglePropertyDialog::AnglePropertyDialog(wxWindow *parent,GAngle* agp)
			 : wxDialog(parent, wxID_ANY,ToolText_Property,wxPoint(15,15), wxSize(500,240))
{
	m_style_list[AGDSN_0]=wxT("Simple");
	m_style_list[AGDSN_1]=wxT("Double");
	m_style_list[AGDSN_2]=wxT("Single segment");
	m_style_list[AGDSN_3]=wxT("Double segments");
	m_style_list[AGDSN_4]=wxT("Circle");
	//name
	int col,row;
	int row0=30,row1=90;
	col=10;
	row=row0;
	new wxStaticText(this, wxID_ANY,wxT("Name  =  "),wxPoint(row,col+3)); row=row1;
	char buffer[32];
	sprintf(buffer,"%s",agp->_name.c_str()); 
	m_Name = new wxTextCtrl(this, wxID_ANY,wxString((char*)buffer,wxConvUTF8),wxPoint(row,col),wxSize(80,20),wxTE_READONLY);
	// style
	col+=30;
	row=row0;
	new wxStaticText(this,wxID_ANY,wxT("Style  = "),wxPoint(row,col+3)); row = row1;
	m_cmb_style = new wxComboBox(this,wxID_ANY,m_style_list[agp->m_angle_design],wxPoint(row,col),wxSize(200,20),AGDSN_MAX,m_style_list);
	// size
	col+=30;
	row=row0;
	new wxStaticText(this, wxID_ANY,wxT("Size  = "),wxPoint(row,col+3)); row=row1;
	m_size = new wxTextCtrl(this,wxID_ANY,wxString::Format(wxT("%d"),agp->m_angle_size),wxPoint(row,col),wxSize(80,20));
	// color
	col+=30;
	row=row0;
	new wxStaticText(this, wxID_ANY,wxT("Color  = "),wxPoint(row,col+3)); row=row1;
	m_ColorR = new wxTextCtrl(this, wxID_ANY,wxString::Format(wxT("%d"),agp->ColR),wxPoint(row,col),wxSize(50,20)); row+=60;
	m_ColorG = new wxTextCtrl(this, wxID_ANY,wxString::Format(wxT("%d"),agp->ColG),wxPoint(row,col),wxSize(50,20)); row+=60;
	m_ColorB = new wxTextCtrl(this, wxID_ANY,wxString::Format(wxT("%d"),agp->ColB),wxPoint(row,col),wxSize(50,20)); row+=60;
	m_RGB = new wxButton(this, AnglePropertyRGB,wxT("RGB"),wxPoint(row,col),wxSize(50,20));
	// ok,cancel
	col+=30;
	m_btnOk = new wxButton(this, wxID_OK, wxT("Ok"),wxPoint(300,col), wxSize(80,20));
	m_btnCancel = new wxButton(this, wxID_CANCEL, wxT("Cancel"),wxPoint(400,col), wxSize(80,20));

}

void AnglePropertyDialog::OnRGB(wxCommandEvent& event)
{
	wxColourDialog dialog(this, &m_ColData);
	if (dialog.ShowModal() == wxID_OK){
		wxColourData retData = dialog.GetColourData();
		wxColour col = retData.GetColour();
		m_ColorR->SetValue(wxString::Format(wxT("%d"),(int)(col.Red())));
		m_ColorG->SetValue(wxString::Format(wxT("%d"),(int)(col.Green())));
		m_ColorB->SetValue(wxString::Format(wxT("%d"),(int)(col.Blue())));

	}
}
