//
//  RButton.cpp
//

#include "wx/wx.h"
#include "KidsCindyCanvas.h"
#include "KidsCindyFrame.h"
#include "resource.h"


void MyCanvas::RButtonDown(wxPoint &point)
{
	m_rbuttondown=true;
	if(SMode){
		return; // Or return one step of the slideshow.
	}
	if(GMode==MODE_KSEG){
		if(!KSEGtexton && !KSEGimageon){
			DocMode=MODE_SINGLE_ADD;
			LDown_SPoint(point);
		}
	}
}

void MyCanvas::RButtonDrag(wxPoint &point)
{
	if(SMode){
		return;
	}
	if(GMode==MODE_KSEG){
		if(!KSEGtexton && !KSEGimageon){
			LDrag_Point(point);
		}
	}
}

void MyCanvas::RButtonUp(wxPoint &point)
{
	m_rbuttondown=false;
	if(SMode){
		return;
	}
	if(GMode==MODE_CINDY){
		LUp_Select(point);
	}
	else if(GMode==MODE_KSEG){
		if(KSEGtexton){
			LUp_Text(point);
		}
		else if(KSEGimageon){
			LUp_Image(point);
		}
		else {
			LUp_SPoint(point);
			m_owner->enableToolbar();
		}
	}
	Refresh(false);
}
